onEvent('recipes', event => {

  // Meadow Dirt to Coarse Dirt
  event.shaped(Item.of("minecraft:coarse_dirt", 4), [
    ["byg:meadow_dirt", "minecraft:gravel", null],
    ["minecraft:gravel", "byg:meadow_dirt", null],
    [null, null, null],
  ])


  // Clayblock back to 4x Clay
  event.shapeless(Item.of('minecraft:clay_ball', 4), ['minecraft:clay'])


  // 3x Gravel to 1x Flint
  event.shapeless(Item.of('minecraft:flint'), ['minecraft:gravel', 'minecraft:gravel', 'minecraft:gravel'])


  // Charm Smooth Glowstone to PT Smooth Glowstone viceversa
  event.shapeless(Item.of('pickletweaks:smooth_glowstone'), ['charm:smooth_glowstone'])
  event.shapeless(Item.of('charm:smooth_glowstone'), ['pickletweaks:smooth_glowstone'])
  event.remove({output: 'pickletweaks:smooth_glowstone'})


  // Animal Feed
  event.remove({output: 'essentials:animal_feed'})
  event.shapeless(Item.of('essentials:animal_feed', 2), ['minecraft:beetroot', 'minecraft:carrot', 'minecraft:baked_potato'])


  // Beach Grass to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:beach_grass', 'byg:beach_grass'])



  // Short Beach Grass to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:short_beach_grass', 'byg:short_beach_grass'])



  // Cattail to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:cattail', 'byg:cattail'])



  // Leaf Pile to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:leaf_pile', 'byg:leaf_pile'])



  // Meadow Dirt to Dirt
  event.shapeless(Item.of('minecraft:dirt'), ['byg:meadow_dirt'])


  // Lizard Egg to Egg
  event.shapeless(Item.of('minecraft:egg'), ['cnb:lizard_egg'])


  // Yeti Hide to 2x Leather
  event.shapeless(Item.of('minecraft:leather', 2), ['cnb:yeti_hide'])


  // Any Sand to Sand
  event.shapeless(Item.of('minecraft:sand'), ['#forge:sand'])


  // White Cherry Foliage to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:white_cherry_foliage', 'byg:white_cherry_foliage'])



  // Pink Foliage to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:pink_cherry_foliage', 'byg:pink_cherry_foliage'])


  // Leather Stripe
  event.remove({id: 'minecraft:leather_to_stripes'})
  event.shapeless(Item.of('betterendforge:leather_stripe', 6), ['minecraft:leather', 'minecraft:leather'])


  // Farmer's Delight Iron Knife to Mystical World
  event.remove({output: 'mysticalworld:iron_knife'})
  event.shapeless(Item.of('mysticalworld:iron_knife'), ['farmersdelight:iron_knife'])


  // Farmer's Delight Gold Knife to Mystical World
  event.remove({output: 'mysticalworld:gold_knife'})
  event.shapeless(Item.of('mysticalworld:gold_knife'), ['farmersdelight:golden_knife'])


  // Farmer's Delight Diamond Knife to Mystical World
  event.remove({output: 'mysticalworld:diamond_knife'})
  event.shapeless(Item.of('mysticalworld:diamond_knife'), ['farmersdelight:diamond_knife'])


  // DruidCraft - Oak Beam
  event.remove({output: 'druidcraft:oak_beam'})
  event.shaped(Item.of('druidcraft:oak_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:oak_log',
  })

  // DruidCraft - Dark Oak Beam
  event.remove({output: 'druidcraft:dark_oak_beam'})
  event.shaped(Item.of('druidcraft:dark_oak_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:dark_oak_log',
  })

  // DruidCraft - Spruce Beam
  event.remove({output: 'druidcraft:spruce_beam'})
  event.shaped(Item.of('druidcraft:spruce_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:spruce_log',
  })

  // DruidCraft - Birch Beam
  event.remove({output: 'druidcraft:birch_beam'})
  event.shaped(Item.of('druidcraft:birch_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:birch_log',
  })

  // DruidCraft - Jungle Beam
  event.remove({output: 'druidcraft:jungle_beam'})
  event.shaped(Item.of('druidcraft:jungle_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:jungle_log',
  })

  // DruidCraft - Acacia Beam
  event.remove({output: 'druidcraft:acacia_beam'})
  event.shaped(Item.of('druidcraft:acacia_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:acacia_log',
  })


  // Angel Ring
event.remove({output: "angelring:itemring" })
  event.shaped(Item.of("angelring:itemring"), [
    ["forbidden_arcanus:bat_wing", "minecraft:gold_block", "forbidden_arcanus:bat_wing"],
    ["minecraft:gold_block", "angelring:itemdiamondring", "minecraft:gold_block"],
    ["forbidden_arcanus:golden_dragon_scale", "minecraft:gold_block", "forbidden_arcanus:golden_dragon_scale"],
  ])


  // Dank 1
  event.replaceInput(
    { id: "dankstorage:1" },
    "minecraft:barrel",
    "#forge:barrels/wooden"
    )


  // Copper Spear
  event.replaceInput(
    { id: "mysticalworld:copper_spear" },
    "mysticalworld:copper_sword",
    "iceandfire:copper_sword"
    )

  // Silver Spear
  event.replaceInput(
    { id: "mysticalworld:silver_spear" },
    "mysticalworld:silver_sword",
    "iceandfire:silver_sword"
    )

  // End Crystal Main Recipe
  event.replaceInput(
    { id: "minecraft:end_crystal" },
    "minecraft:glass",
    "#forge:glass"
    )

  // End Crystal Alternate Recipe #1
  event.shaped(Item.of('minecraft:end_crystal'), [
    'GGG',
    'GCG',
    'GTG'
  ], {
    G: '#forge:glass',
    C: 'silentgems:ender_crystal_block',
    T: 'minecraft:ghast_tear'
  })

  // End Crystal Alternate Recipe #2
  event.shaped(Item.of('minecraft:end_crystal'), [
    'GGG',
    'GCG',
    'GTG'
  ], {
    G: '#forge:glass',
    C: '#forge:storage_blocks/manyullyn',
    T: 'minecraft:ghast_tear'
  })

  // End Crystal Alternate Recipe #3
  event.shaped(Item.of('minecraft:end_crystal'), [
    'GGG',
    'GCG',
    'GTG'
  ], {
    G: '#forge:glass',
    C: 'appliedenergistics2:fluix_block',
    T: 'minecraft:ghast_tear'
  })

  // End Crystal Alternate Recipe #4
  event.shaped(Item.of('minecraft:end_crystal'), [
    'GGG',
    'GCG',
    'GTG'
  ], {
    G: '#forge:glass',
    C: '#forge:storage_blocks/pendorite',
    T: 'minecraft:ghast_tear'
  })

  // End Crystal Alternate Recipe #5
  event.shaped(Item.of('minecraft:end_crystal'), [
    'GGG',
    'GCG',
    'GTG'
  ], {
    G: '#forge:glass',
    C: '#forge:storage_blocks/azure_silver',
    T: 'minecraft:ghast_tear'
  })

  // Palm Ladder - BDB
  event.replaceInput(
    { id: "betterdefaultbiomes:palm_ladder" },
    "betterdefaultbiomes:palm_planks",
    "#forge:planks/palm"
    )

  // Palm Boat - BYG
  event.replaceInput(
    { id: "byg:palm_boat" },
    "byg:palm_planks",
    "#forge:planks/palm"
    )

  // Palm Bookshelf - BYG
  event.replaceInput(
    { id: "byg:palm_bookshelf" },
    "byg:palm_planks",
    "#forge:planks/palm"
    )


  // Ultra Exporter
  event.replaceInput(
    { id: "cabletiers:ultra_exporter" },
    "cabletiers:elite_exporter",
    "extrastorage:advanced_exporter"
    )

  // Ultra Importer
  event.replaceInput(
    { id: "cabletiers:ultra_importer" },
    "cabletiers:elite_importer",
    "extrastorage:advanced_importer"
    )


  // Shrinking Device
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "#forge:glass",
    "immersiveengineering:circuit_board"
    )


  // Shrinking Device 2
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "minecraft:ender_pearl",
    "rftoolsbase:infused_enderpearl"
    )


  // Shrinking Device 3
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "minecraft:stone_button",
    "rftoolscontrol:cpu_core_1000"
    )


  // Shrinking Device 4
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "minecraft:iron_ingot",
    "#forge:ingots/compressed_iron"
    )



  // Diamond Ring
  event.replaceInput(
    { id: "angelring:itemdiamondring" },
    "minecraft:elytra",
    "enigmaticlegacy:fabulous_scroll"
    )


  // Ring of Ender
  event.replaceInput(
    { id: "enigmaticlegacy:ender_ring" },
    "enigmaticlegacy:iron_ring",
    "enigmaticlegacy:gem_ring"
    )



  // Building Gadget
event.remove({output: "buildinggadgets:gadget_building" })
  event.shaped(Item.of("buildinggadgets:gadget_building"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:diamond", "rftoolscontrol:cpu_core_500", "minecraft:diamond"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Copy-Paste Gadget
event.remove({output: "buildinggadgets:gadget_copy_paste" })
  event.shaped(Item.of("buildinggadgets:gadget_copy_paste"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:emerald", "rftoolscontrol:cpu_core_500", "minecraft:emerald"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Destruction Gadget
event.remove({output: "buildinggadgets:gadget_destruction" })
  event.shaped(Item.of("buildinggadgets:gadget_destruction"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:ender_pearl", "rftoolscontrol:cpu_core_1000", "minecraft:ender_pearl"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Exchanging Gadget
event.remove({output: "buildinggadgets:gadget_exchanging" })
  event.shaped(Item.of("buildinggadgets:gadget_exchanging"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:diamond", "minecraft:lapis_lazuli", "minecraft:diamond"],
    ["minecraft:iron_ingot", "rftoolscontrol:cpu_core_1000", "minecraft:iron_ingot"],
  ])

  // Template Manager
event.remove({output: "buildinggadgets:template_manager" })
  event.shaped(Item.of("buildinggadgets:template_manager"), [
    ["minecraft:gold_ingot", "minecraft:redstone", "minecraft:gold_ingot"],
    ["minecraft:emerald", "rftoolscontrol:cpu_core_2000", "minecraft:emerald"],
    ["minecraft:gold_ingot", "minecraft:lapis_lazuli", "minecraft:gold_ingot"],
  ])



  // Entangled Block
event.remove({output: "entangled:block" })
  event.shaped(Item.of("entangled:block"), [
    ["minecraft:ender_pearl", "minecraft:obsidian", "minecraft:ender_pearl"],
    ["minecraft:obsidian", "#forge:chests/wooden", "minecraft:obsidian"],
    ["minecraft:ender_pearl", "minecraft:obsidian", "minecraft:ender_pearl"],
  ])



  // Magnetism Ring
  event.shaped(Item.of('ringsofascension:ring_magnetism'), [
    ' I ',
    'IEI',
    'RIB'
  ], {
    I: 'minecraft:iron_ingot',
    E: 'minecraft:ender_pearl',
    R: '#forge:dyes/red',
    B: '#forge:dyes/blue'
  })



  // Pied Wool
  event.shaped(Item.of('rats:pied_wool'), [
    'WG ',
    'YW ',
    '   '
  ], {
    W: 'minecraft:white_wool',
    G: '#forge:dyes/green',
    Y: '#forge:dyes/yellow'
  })



  // Cursed Ring
  event.shaped(Item.of('enigmaticlegacy:cursed_ring'), [
    'GNH',
    'NRN',
    'ENE'
  ], {
    H: 'enigmaticlegacy:earth_heart',
    G: 'enigmaticlegacy:golem_heart',
    E: 'enigmaticlegacy:etherium_ingot',
    R: 'enigmaticlegacy:ender_ring',
    N: 'minecraft:netherite_ingot'
  })
  


  // Mining Dim - Block
    event.remove({id: 'mining_dimension:teleporter'})
    event.shaped(Item.of("mining_dimension:teleporter"), [
    ["minecraft:gold_block", "#minecraft:logs", "minecraft:gold_block"],
    ["#minecraft:logs", "minecraft:golden_pickaxe", "#minecraft:logs"],
    ["minecraft:gold_block", "#minecraft:logs", "minecraft:gold_block"],
  ])



  // Dusts
  event.replaceOutput(
    { id: "engineerstools:crushing/uranium_grit_crushing_recipe" },
    "immersiveengineering:dust_uranium",
    "silents_mechanisms:uranium_dust"
    )



  // Tesseract
  event.remove({id: 'tesseract:tesseract'})
  event.shaped(Item.of('tesseract:tesseract'), [
    'OUF',
    'ATA',
    'FUO'
  ], {
    O: 'minecraft:obsidian',
    A: 'mekanism:alloy_atomic',
    F: 'fluxnetworks:flux_block',
    T: 'mekanism:teleportation_core',
    U: 'mekanism:ultimate_control_circuit'
  })


  // Golden Melon Slice #1
  event.shaped(Item.of('kubejs:golden_melon_slice'), [
    'NIN',
    'IMI',
    'NIN'
  ], {
    M: 'minecraft:melon_slice',
    N: 'minecraft:gold_nugget',
    I: 'minecraft:gold_ingot'
  })


  // Golden Melon Slice #5
  event.shaped(Item.of('kubejs:golden_melon_slice'), [
    'NIN',
    'IMI',
    'NIN'
  ], {
    M: 'pamhc2crops:cantaloupeitem',
    N: 'minecraft:gold_nugget',
    I: 'minecraft:gold_ingot'
  })


  // Golden Berries #1
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'minecraft:sweet_berries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #2
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'byg:holly_berries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #3
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'druidcraft:elderberries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #4
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'byg:nightshade_berries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #5
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'druidcraft:blueberries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #6
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'byg:blueberries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #7
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'byg:crimson_berries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #8
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'outer_end:azure_berries',
    G: 'minecraft:gold_nugget'
  })



  // Golden Berries #9
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'ars_nouveau:mana_berry',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #10
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:blackberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #11
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:blueberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #12
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:candleberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #13
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:cranberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #14
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:elderberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #15
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:huckleberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #16
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:juniperberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #17
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:mulberryitem',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #18
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2crops:raspberryitem',
    G: 'minecraft:gold_nugget'
  })

  // Golden Berries #23
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'integrateddynamics:menril_berries',
    G: 'minecraft:gold_nugget'
  })


  // Golden Berries #24
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'pamhc2trees:gooseberryitem',
    G: 'minecraft:gold_nugget'
  })

  // Golden Berries #25
  event.shaped(Item.of('kubejs:golden_berries'), [
    'GGG',
    'GSG',
    'GGG'
  ], {
    S: 'autumnity:foul_berries',
    G: 'minecraft:gold_nugget'
  })

  // Honeycomb Button
    event.remove({output: "variant16x:honeycomb_button" })
    event.shapeless(Item.of('variant16x:honeycomb_button'), ['#minecraft:wooden_buttons', 'minecraft:honeycomb_block'])

  // Warped Button
    event.remove({output: "variant16x:warped_hyphae_button" })
    event.shapeless(Item.of('variant16x:warped_hyphae_button'), ['#minecraft:wooden_buttons', '#minecraft:warped_stems'])

  // Crimson Button
    event.remove({output: "variant16x:crimson_hyphae_button" })
    event.shapeless(Item.of('variant16x:crimson_hyphae_button'), ['#minecraft:wooden_buttons', '#minecraft:crimson_stems'])

  // Dark Oak Button
    event.remove({output: "variant16x:dark_oak_wood_button" })
    event.shapeless(Item.of('variant16x:dark_oak_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:dark_oak_logs'])

  // Acacia Button
    event.remove({output: "variant16x:acacia_wood_button" })
    event.shapeless(Item.of('variant16x:acacia_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:acacia_logs'])

  // Jungle Button
    event.remove({output: "variant16x:jungle_wood_button" })
    event.shapeless(Item.of('variant16x:jungle_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:jungle_logs'])

  // Birch Button
    event.remove({output: "variant16x:birch_wood_button" })
    event.shapeless(Item.of('variant16x:birch_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:birch_logs'])

  // Spruce Button
    event.remove({output: "variant16x:spruce_wood_button" })
    event.shapeless(Item.of('variant16x:spruce_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:spruce_logs'])

  // Oak Button
    event.remove({output: "variant16x:oak_wood_button" })
    event.shapeless(Item.of('variant16x:oak_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:oak_logs'])


  
  // Forbidden And Arcanus - Batwing to Reliquary Batwing
    event.shapeless(Item.of('xreliquary:bat_wing'), ['forbidden_arcanus:bat_wing'])



  // Reliquary - Batwing Batwing to Forbidden And Arcanus Batwing
    event.shapeless(Item.of('forbidden_arcanus:bat_wing'), ['xreliquary:bat_wing'])


  // IE - Steel Sword
  event.replaceInput(
    { id: "immersiveengineering:crafting/sword_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Pickaxe
  event.replaceInput(
    { id: "immersiveengineering:crafting/pickaxe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Shovel
  event.replaceInput(
    { id: "immersiveengineering:crafting/shovel_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Axe
  event.replaceInput(
    { id: "immersiveengineering:crafting/axe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Hoe
  event.replaceInput(
    { id: "immersiveengineering:crafting/hoe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )



  // Sythian Stalk to 2x Bamboo
  event.shaped(Item.of('minecraft:bamboo', 2), [
    ' S ',
    'SGS',
    ' S '
  ], {
    S: 'byg:sythian_stalk_block',
    G: 'minecraft:green_dye'
  })



  // Osmium Ore Chunks to Osmium Ingot
  event.smelting(Item.of('mekanism:ingot_osmium', 1), 'kubejs:osmium_chunks').xp(1.0)
  event.blasting(Item.of('mekanism:ingot_osmium', 1), 'kubejs:osmium_chunks').xp(1.0)



  // Yellorite Ore Chunks to Yellorium Ingot
  event.smelting(Item.of('biggerreactors:yellorium_ingot', 1), 'kubejs:yellorite_chunks').xp(1.0)
  event.blasting(Item.of('biggerreactors:yellorium_ingot', 1), 'kubejs:yellorite_chunks').xp(1.0)


  // Quicksilver Ore Chunks to Yellorium Ingot
  event.smelting(Item.of('mysticalworld:quicksilver_ingot', 1), 'kubejs:quicksilver_chunks').xp(1.0)
  event.blasting(Item.of('mysticalworld:quicksilver_ingot', 1), 'kubejs:quicksilver_chunks').xp(1.0)


  // MC Sweet Berries to Red Dye
  event.shapeless(Item.of('minecraft:red_dye'), ['minecraft:sweet_berries', 'minecraft:sweet_berries', 'minecraft:sweet_berries'])



  // BYG Blueberries to Blue Dye Fix
  event.remove({id: 'byg:blue_dye'})
  event.shapeless(Item.of('minecraft:blue_dye'), ['byg:blueberries', 'byg:blueberries', 'byg:blueberries'])


  // Actual Flint And Steel
  event.shapeless(Item.of('minecraft:flint_and_steel'), ['#forge:ingots/steel', 'minecraft:flint'])


  // BYG Azalea to Light Blue Dye
  event.shapeless(Item.of('minecraft:light_blue_dye', 2), ['byg:azalea'])


  // Ars Nouveau Source Berry to Purple Dye
  event.shapeless(Item.of('minecraft:purple_dye'), ['ars_nouveau:mana_berry', 'ars_nouveau:mana_berry', 'ars_nouveau:mana_berry'])


  // Thermal - Flux Efficiency
  event.shaped(Item.of('thermal:machine_efficiency_augment'), [
    ' G ',
    'PCP',
    ' G '
  ], {
    G: '#forge:gears/iron',
    P: '#forge:plates/silver',
    C: 'thermal:rf_coil'
  })


  // Astral Sorcery - Marble Bricks Slab
  event.remove({id: 'astralsorcery:shaped/marble/marble_slab'})
  event.shaped(Item.of('astralsorcery:marble_slab', 6), [
    '   ',
    'BBB',
    '   '
  ], {
    B: 'astralsorcery:marble_bricks',
  })



  // Astral Sorcery - Marble Bricks Stairs
  event.remove({id: 'astralsorcery:shaped/marble/marble_stairs'})
  event.shaped(Item.of('astralsorcery:marble_stairs', 6), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'astralsorcery:marble_bricks',
  })



  // Astral Sorcery - Sooty Marble Bricks Slab
  event.remove({id: 'astralsorcery:shaped/black_marble/black_marble_slab'})
  event.shaped(Item.of('astralsorcery:black_marble_slab', 6), [
    '   ',
    'BBB',
    '   '
  ], {
    B: 'astralsorcery:black_marble_bricks',
  })



  // Astral Sorcery - Sooty Marble Bricks Stairs
  event.remove({id: 'astralsorcery:shaped/black_marble/black_marble_stairs'})
  event.shaped(Item.of('astralsorcery:black_marble_stairs', 6), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'astralsorcery:black_marble_bricks',
  })



  // PickleTweaks Watering Can
  event.remove({id: 'pickletweaks:watering_can'})
  event.shaped(Item.of('pickletweaks:watering_can'), [
    ' NI',
    'IBI',
    ' I '
  ], {
    N: 'minecraft:iron_nugget',
    I: 'minecraft:iron_ingot',
    B: 'minecraft:bowl'
  })




  // Iron Jetpacks Wooden Items
  event.shaped(Item.of('ironjetpacks:wood_jetpack'), [
    'PCP',
    'PSP',
    'T T'
  ], {
    T: 'ironjetpacks:wood_thruster',
    C: 'ironjetpacks:wood_capacitor',
    S: 'ironjetpacks:strap',
    P: '#minecraft:planks'
  })



  event.shaped(Item.of('ironjetpacks:wood_cell'), [
    ' R ',
    'PCP',
    ' R '
  ], {
    C: 'ironjetpacks:basic_coil',
    R: 'minecraft:redstone',
    P: '#minecraft:planks'
  })



  event.shaped(Item.of('ironjetpacks:wood_capacitor'), [
    'PCP',
    'PCP',
    'PCP'
  ], {
    C: 'ironjetpacks:wood_cell',
    P: '#minecraft:planks'
  })



  event.shaped(Item.of('ironjetpacks:wood_thruster'), [
    'PCP',
    'CEC',
    'PFP'
  ], {
    C: 'ironjetpacks:basic_coil',
    E: 'ironjetpacks:wood_cell',
    P: '#minecraft:planks',
    F: 'minecraft:furnace'
  })



  event.shaped(Item.of('ironjetpacks:strap'), [
    ' N ',
    'LLL',
    ' N '
  ], {
    L: 'minecraft:leather',
    N: 'minecraft:iron_nugget'
  })



  event.shaped(Item.of('ironjetpacks:basic_coil'), [
    ' ID',
    'IRI',
    'DI '
  ], {
    I: 'minecraft:iron_ingot',
    R: '#forge:rods/wooden',
    D: 'minecraft:redstone'
  })


  event.shaped(Item.of('ironjetpacks:advanced_coil'), [
    ' ID',
    'IRI',
    'DI '
  ], {
    I: 'minecraft:gold_ingot',
    R: '#forge:rods/wooden',
    D: 'minecraft:redstone'
  })


  event.shaped(Item.of('ironjetpacks:elite_coil'), [
    ' ID',
    'IRI',
    'DI '
  ], {
    I: 'minecraft:diamond',
    R: '#forge:rods/wooden',
    D: 'minecraft:redstone'
  })


  event.shaped(Item.of('ironjetpacks:ultimate_coil'), [
    ' ID',
    'IRI',
    'DI '
  ], {
    I: 'minecraft:emerald',
    R: '#forge:rods/wooden',
    D: 'minecraft:redstone'
  })



  // Loot Bag Pieces to Loot Bag
  event.shaped(Item.of("lootbagmod:lootbag"), [
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
  ])


  // Farmer's Delight Flint Knife
  event.remove({output: 'farmersdelight:flint_knife'})
  event.shaped(Item.of('farmersdelight:flint_knife'), [
    '  F',
    ' S ',
    'S  '
  ], {
    S: '#forge:rods/wooden',
    F: 'minecraft:flint'
  })



  // Chain Plating BYG
  event.remove({id: 'byg:chain_plating'})
  event.shaped(Item.of('byg:chain_plating', 4), [
    'INI',
    'N N',
    'INI'
  ], {
    I: 'minecraft:iron_ingot',
    N: 'minecraft:iron_nugget'
  })


  // Farmer's Delight Fried Egg #1
  event.replaceInput(
    { id: "farmersdelight:fried_egg_from_campfire_cooking" },
    "minecraft:egg",
    "#forge:eggs"
    )


  // Farmer's Delight Fried Egg #2
  event.replaceInput(
    { id: "farmersdelight:fried_egg" },
    "minecraft:egg",
    "#forge:eggs"
    )


  // Farmer's Delight Fried Egg #3
  event.replaceInput(
    { id: "farmersdelight:fried_egg_from_smoking" },
    "minecraft:egg",
    "#forge:eggs"
    )


  // Extra Disks Stuff
  event.replaceInput(
    { id: "extradisks:part/65536k_storage_part" },
    "extradisks:16384k_storage_part",
    "extrastorage:storagepart_16384k"
    )

  event.replaceInput(
    { id: "extradisks:part/infinite_fluid_storage_part" },
    "extradisks:1048576k_fluid_storage_part",
    "extrastorage:storagepart_1048576k_fluid"
    )



  // BDB - Tall Water Reeds to Sticks
  event.shaped(Item.of('minecraft:stick'), [
    'R  ',
    'R  ',
    '   '
  ], {
    R: 'betterdefaultbiomes:tall_water_reeds',
  })



  // Flux Plug
  event.remove({output: "fluxnetworks:flux_plug" })
  event.shaped(Item.of('fluxnetworks:flux_plug', 2), [
    ' F ',
    'FTF',
    ' F '
  ], {
    F: 'fluxnetworks:flux_core',
    T: 'tesseract:tesseract'
  })



  // Flux Point
  event.remove({output: "fluxnetworks:flux_point" })
  event.shaped(Item.of('fluxnetworks:flux_point'), [
    ' F ',
    'FTF',
    ' F '
  ], {
    F: 'fluxnetworks:flux_core',
    T: 'mekanism:teleportation_core'
  })


    // Apple to Baked Apple
  event.smelting(Item.of('kubejs:baked_apple', 1), 'minecraft:apple').xp(0.30)
  event.smoking(Item.of('kubejs:baked_apple', 1), 'minecraft:apple').xp(0.30)


    // Green Apple to Green Baked Apple
  event.smelting(Item.of('kubejs:green_baked_apple', 1), 'byg:green_apple').xp(0.30)
  event.smoking(Item.of('kubejs:green_baked_apple', 1), 'byg:green_apple').xp(0.30)


  // Assorted Vegetables
  event.remove({id: "rats:assorted_vegetables"})
  event.shaped(Item.of('rats:assorted_vegetables'), [
    'VVV',
    'VVV',
    'VV '
  ], {
    V: '#forge:vegetables',
  })


  // External Heater
  event.shaped(Item.of('immersiveengineering:furnace_heater'), [
    'ICI',
    'CLC',
    'IRI'
  ], {
    I: 'minecraft:iron_ingot',
    C: '#forge:ingots/copper',
    R: 'minecraft:redstone',
    L: 'immersiveengineering:coil_lv'
  })


  // Maple Fence
  event.remove({id: "byg:maple_fence"})
  event.shaped(Item.of('byg:maple_fence', 3), [
    '   ',
    'PRP',
    'PRP'
  ], {
    R: '#forge:rods/wooden',
    P: 'byg:maple_planks'
  })


  event.replaceInput(
    { id: "byg:maple_fence_gate" },
    "minecraft:stick",
    "#forge:rods/wooden"
    )


  // Comforts - White Sleeping Bag
  event.remove({id: "comforts:sleeping_bag_white"})
  event.shaped(Item.of('comforts:sleeping_bag_white'), [
    'S S',
    'WWW',
    'S S'
  ], {
    S: '#forge:rods/wooden',
    W: 'minecraft:white_wool'
  })


  // Mystical Agriculture Enderium Essence Craft
  event.remove({id: "mysticalagriculture:essence/thermal/enderium_ingot"})
  event.shaped(Item.of('thermal:enderium_ingot', 2), [
    'EEE',
    'E E',
    'EEE'
  ], {
    E: 'mysticalagriculture:enderium_essence',
  })


  // Mystical Agriculture Lumium Essence Craft
  event.remove({id: "mysticalagriculture:essence/thermal/lumium_ingot"})
  event.shaped(Item.of('thermal:lumium_ingot', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: 'mysticalagriculture:lumium_essence',
  })


  // Mystical Agriculture Signalum Essence Craft
  event.remove({id: "mysticalagriculture:essence/thermal/signalum_ingot"})
  event.shaped(Item.of('thermal:signalum_ingot', 4), [
    'SSS',
    'S S',
    'SSS'
  ], {
    S: 'mysticalagriculture:signalum_essence',
  })


  // Mystical Agriculture Constantan Essence Craft
  event.shaped(Item.of('thermal:constantan_ingot', 4), [
    'CCC',
    'C C',
    'CCC'
  ], {
    C: 'mysticalagriculture:constantan_essence',
  })



  // Mystical Agriculture Invar Essence Craft
  event.shaped(Item.of('thermal:invar_ingot', 4), [
    'III',
    'I I',
    'III'
  ], {
    I: 'mysticalagriculture:invar_essence',
  })



  // Mystical Agriculture Electrum Essence Craft
  event.shaped(Item.of('thermal:electrum_ingot', 4), [
    'EEE',
    'E E',
    'EEE'
  ], {
    E: 'mysticalagriculture:electrum_essence',
  })



  // Mystical Agriculture Bronze Essence Craft
  event.shaped(Item.of('thermal:bronze_ingot', 4), [
    'BBB',
    'B B',
    'BBB'
  ], {
    B: 'mysticalagriculture:bronze_essence',
  })



  // Mystical Agriculture Nickel Essence Craft
  event.shaped(Item.of('thermal:nickel_ingot', 4), [
    'NNN',
    'N N',
    'NNN'
  ], {
    N: 'mysticalagriculture:nickel_essence',
  })



  // Mystical Agriculture Silver Essence Craft
  event.shaped(Item.of('thermal:silver_ingot', 4), [
    'SSS',
    'S S',
    'SSS'
  ], {
    S: 'mysticalagriculture:silver_essence',
  })



  // Mystical Agriculture Lead Essence Craft
  event.shaped(Item.of('thermal:lead_ingot', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: 'mysticalagriculture:lead_essence',
  })


  // Mystical Agriculture Tin Essence Craft
  event.shaped(Item.of('thermal:tin_ingot', 4), [
    'TTT',
    'T T',
    'TTT'
  ], {
    T: 'mysticalagriculture:tin_essence',
  })



  // Mystical Agriculture Copper Essence Craft
  event.shaped(Item.of('thermal:copper_ingot', 4), [
    'CCC',
    'C C',
    'CCC'
  ], {
    C: 'mysticalagriculture:copper_essence',
  })



  // Time in a Bottle
  event.remove({output: "tiab:timeinabottle" })
  event.shaped(Item.of('tiab:timeinabottle'), [
    'GTG',
    'DCD',
    'YBY'
  ], {
    G: 'minecraft:gold_block',
    D: 'minecraft:diamond',
    C: 'minecraft:clock',
    B: 'kubejs:timeless_bottle',
    T: 'minecraft:ghast_tear',
    Y: 'forbidden_arcanus:ender_pearl_fragment'
  })



  // Timeless Bottle
  event.shaped(Item.of('kubejs:timeless_bottle'), [
    ' L ',
    'GHG',
    ' G '
  ], {
    G: 'forbidden_arcanus:arcane_glass',
    H: 'supplementaries:hourglass',
    L: '#botania:petals/lime'
  })



  // Ladder - Oak
  event.shaped(Item.of('minecraft:ladder', 3), [
    'S S',
    'SSS',
    'S S'
  ], {
    S: '#forge:rods/wooden',
  })



  event.shaped(Item.of("appliedenergistics2:silicon", 6), [
    [null, "mysticalagriculture:silicon_essence", null], 
    [null, "mysticalagriculture:silicon_essence", null], 
    [null, "mysticalagriculture:silicon_essence", null],
  ])



  // Forbidden and Arcanus - Jar
  event.replaceInput(
    { id: "forbidden_arcanus:bottle_block" },
    "#minecraft:planks",
    "#minecraft:wooden_slabs"
    )


  // Supplementaries - Jar
  event.replaceInput(
    { id: "supplementaries:jar_recipe" },
    "#minecraft:wooden_slabs",
    "#minecraft:logs"
    )



  // Mystical Agriculture IF - Rubber Craft
  event.shaped(Item.of('industrialforegoing:dryrubber'), [
    ' R ',
    ' R ',
    ' R '
  ], {
    R: 'mysticalagriculture:rubber_essence',
  })



  // Mystical Agriculture Thermal - Rubber Craft
  event.shaped(Item.of('thermal:rubber', 2), [
    '   ',
    'RRR',
    '   '
  ], {
    R: 'mysticalagriculture:rubber_essence',
  })



  event.remove({id: "rats:plastic_smelting"})
  event.remove({id: "rats:plastic_blast_furnace"})
  event.smelting(Item.of('kubejs:tiny_plastic_piece', 1), 'rats:plastic_waste').xp(0.05)
  event.blasting(Item.of('kubejs:tiny_plastic_piece', 1), 'rats:plastic_waste').xp(0.05)



  // Processed Plastic
  event.shaped(Item.of("kubejs:processed_plastic"), [
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"], 
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"], 
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"],
  ])



  event.smelting(Item.of('industrialforegoing:plastic', 1), 'kubejs:processed_plastic').xp(0.05)
  event.blasting(Item.of('industrialforegoing:plastic', 1), 'kubejs:processed_plastic').xp(0.05)



  // Yellorium Nuggets
  event.shapeless(Item.of('kubejs:yellorium_nugget', 9), ['biggerreactors:yellorium_ingot'])



  // Yellorium Ingot from Nugget
  event.shaped(Item.of("biggerreactors:yellorium_ingot"), [
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"], 
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"], 
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"],
  ])



  // Powered Anvil 1
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )



  // Powered Anvil 2
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:iron_block",
    "#forge:storage_blocks/compressed_iron"
    )



  // Powered Anvil 3
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:redstone",
    "silents_mechanisms:redstone_alloy_ingot"
    )



  // Magma Anvil 1
  event.replaceInput(
    { id: "cyclic:anvil_magma" },
    "minecraft:magma_block",
    "craftandhunt:blaze_glass_block"
    )

  // Magma Anvil 2
  event.replaceInput(
    { id: "cyclic:anvil_magma" },
    "minecraft:obsidian",
    "minecraft:crying_obsidian"
    )

  // Mason Steel
  event.replaceInput(
    { id: "cyclic:mason_steel" },
    "minecraft:iron_block",
    "#forge:storage_blocks/compressed_iron"
    )



  // Crystal Sword
  event.replaceInput(
    { id: "cyclic:crystal_sword" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Pickaxe
  event.replaceInput(
    { id: "cyclic:crystal_pickaxe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Shovel
  event.replaceInput(
    { id: "cyclic:crystal_shovel" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Axe
  event.replaceInput(
    { id: "cyclic:crystal_axe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Hoe
  event.replaceInput(
    { id: "cyclic:crystal_hoe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )



  // Dusts to Dusts
  event.shapeless(Item.of('thermal:quartz_dust'), ['#forge:dusts/quartz'])



  // Pig Fat
  event.remove({id: 'extlights:pig_fat_craft'})
  event.shapeless(Item.of('extlights:pig_fat', 2), ['minecraft:porkchop', 'minecraft:porkchop'])



  // Quark Marble to Astral Marble and vice versa
  event.shapeless(Item.of('astralsorcery:marble_raw'), ['quark:marble'])
  event.shapeless(Item.of('quark:marble'), ['astralsorcery:marble_raw'])



  // AE2 - Calculation Press
  event.shaped(Item.of("appliedenergistics2:calculation_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "appliedenergistics2:purified_certus_quartz_crystal", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Engineering Press
  event.shaped(Item.of("appliedenergistics2:engineering_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "immersiveengineering:toolbox", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Logic Press
  event.shaped(Item.of("appliedenergistics2:logic_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "rftoolsutility:logic", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Silicon Press
  event.shaped(Item.of("appliedenergistics2:silicon_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "#appliedenergistics2:silicon", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])



  // Uranium Stuff
  event.replaceInput(
    { id: "silents_mechanisms:metals/uranium_block" },
    "#forge:ingots/uranium",
    "silents_mechanisms:uranium_ingot"
    )

  event.replaceInput(
    { id: "silents_mechanisms:metals/uranium_nugget" },
    "#forge:ingots/uranium",
    "silents_mechanisms:uranium_ingot"
  )


  // Expanded Storage - Netherite Chest
  event.remove({id: 'expandedstorage:netherite_chest'})
  event.smithing('expandedstorage:netherite_chest', 'expandedstorage:obsidian_chest', 'minecraft:netherite_ingot')

  // Expanded Storage - Wood to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:wood_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:wood_to_netherite_conversion_kit', 'expandedstorage:wood_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Obsidian to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:obsidian_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:obsidian_to_netherite_conversion_kit', 'minecraft:obsidian', 'minecraft:netherite_ingot')

  // Expanded Storage - Diamond to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:diamond_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:diamond_to_netherite_conversion_kit', 'expandedstorage:diamond_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Gold to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:gold_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:gold_to_netherite_conversion_kit', 'expandedstorage:gold_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Iron to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:iron_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:iron_to_netherite_conversion_kit', 'expandedstorage:iron_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')



  // Craft and Hunt - Wither Sword
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_sword'})
  event.smithing('craftandhunt:wither_sword', 'craftandhunt:bone_sword', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Pickaxe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_pickaxe'})
  event.smithing('craftandhunt:wither_pickaxe', 'craftandhunt:bone_pickaxe', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Shovel
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_shovel'})
  event.smithing('craftandhunt:wither_shovel', 'craftandhunt:bone_shovel', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Axe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_axe'})
  event.smithing('craftandhunt:wither_axe', 'craftandhunt:bone_axe', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Hoe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_hoe'})
  event.smithing('craftandhunt:wither_hoe', 'craftandhunt:bone_hoe', 'minecraft:wither_skeleton_skull')



  // Forbidden and Arcanus (CAH) - Wither Sword
  event.smithing('craftandhunt:wither_sword', 'forbidden_arcanus:bone_sword', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Pickaxe
  event.smithing('craftandhunt:wither_pickaxe', 'forbidden_arcanus:bone_pickaxe', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Shovel
  event.smithing('craftandhunt:wither_shovel', 'forbidden_arcanus:bone_shovel', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Axe
  event.smithing('craftandhunt:wither_axe', 'forbidden_arcanus:bone_axe', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Hoe
  event.smithing('craftandhunt:wither_hoe', 'forbidden_arcanus:bone_hoe', 'minecraft:wither_skeleton_skull')



  // DruidCraft to Forbidden and Arcanus (CAH) - Wither Sword
  event.smithing('craftandhunt:wither_sword', 'druidcraft:bone_sword', 'minecraft:wither_skeleton_skull')

  // DruidCraft to Forbidden and Arcanus (CAH) - Wither Pickaxe
  event.smithing('craftandhunt:wither_pickaxe', 'druidcraft:bone_pickaxe', 'minecraft:wither_skeleton_skull')

  // DruidCraft to Forbidden and Arcanus (CAH) - Wither Shovel
  event.smithing('craftandhunt:wither_shovel', 'druidcraft:bone_shovel', 'minecraft:wither_skeleton_skull')

  // DruidCraft to Forbidden and Arcanus (CAH) - Wither Axe
  event.smithing('craftandhunt:wither_axe', 'druidcraft:bone_axe', 'minecraft:wither_skeleton_skull')

  // DruidCraft to Forbidden and Arcanus (CAH) - Wither Hoe
  event.smithing('craftandhunt:wither_hoe', 'druidcraft:bone_hoe', 'minecraft:wither_skeleton_skull')


  // Iron Chain
  event.remove({id: 'forbidden_arcanus:iron_chain'})
  event.shaped(Item.of('forbidden_arcanus:iron_chain', 3), [
    '  N',
    ' I ',
    'N  '
  ], {
    N: 'minecraft:iron_nugget',
    I: 'minecraft:iron_ingot'
  });



  // Druidcraft Bone Helmet
  event.remove({id: 'druidcraft:bone_helmet'})
  event.shaped(Item.of('druidcraft:bone_helmet'), [
    'BBB',
    'BFB',
    '   '
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Chestplate
  event.remove({id: 'druidcraft:bone_chestplate'})
  event.shaped(Item.of('druidcraft:bone_chestplate'), [
    'BFB',
    'BBB',
    'BBB'
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Leggings
  event.remove({id: 'druidcraft:bone_leggings'})
  event.shaped(Item.of('druidcraft:bone_leggings'), [
    'BBB',
    'BFB',
    'B B'
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Boots
  event.remove({id: 'druidcraft:bone_boots'})
  event.shaped(Item.of('druidcraft:bone_boots'), [
    '   ',
    'B B',
    'BFB'
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })



  // Hoglin Helmet
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_helmet'})
  event.shaped(Item.of('craftandhunt:hoglin_helmet'), [
    'BBB',
    'B B',
    '   '
  ], {
    B: 'craftandhunt:hoglin_leather',
  })

  // Hoglin Chestplate
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_chestplate'})
  event.shaped(Item.of('craftandhunt:hoglin_chestplate'), [
    'B B',
    'BBB',
    'BBB'
  ], {
    B: 'craftandhunt:hoglin_leather',
  })

  // Hoglin Leggings
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_leggings'})
  event.shaped(Item.of('craftandhunt:hoglin_leggings'), [
    'BBB',
    'B B',
    'B B'
  ], {
    B: 'craftandhunt:hoglin_leather',
  })

  // Hoglin Boots
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_boots'})
  event.shaped(Item.of('craftandhunt:hoglin_boots'), [
    '   ',
    'B B',
    'B B'
  ], {
    B: 'craftandhunt:hoglin_leather',
  })



  // Druidcraft Bone Sword
  event.remove({id: 'druidcraft:bone_sword'})
  event.shaped(Item.of('druidcraft:bone_sword'), [
    ' B ',
    ' B ',
    'FSF'
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Pickaxe
  event.remove({id: 'druidcraft:bone_pickaxe'})
  event.shaped(Item.of('druidcraft:bone_pickaxe'), [
    'BBB',
    ' F ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Shovel
  event.remove({id: 'druidcraft:bone_shovel'})
  event.shaped(Item.of('druidcraft:bone_shovel'), [
    ' B ',
    ' F ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Axe
  event.remove({id: 'druidcraft:bone_axe'})
  event.shaped(Item.of('druidcraft:bone_axe'), [
    'BB ',
    'BF ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Hoe
  event.remove({id: 'druidcraft:bone_hoe'})
  event.shaped(Item.of('druidcraft:bone_hoe'), [
    'BB ',
    ' F ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })


  // Wooden Barrel Fix
  event.remove({output: 'minecraft:barrel'})
  event.shaped(Item.of('minecraft:barrel'), [
    'PSP',
    'PSP',
    'PSP'
  ], {
    P: '#minecraft:planks',
    S: '#minecraft:wooden_slabs'
  })


  // 2x Bone to 8x Bone Fragments
  event.shapeless(Item.of('kubejs:bone_fragment', 8), ['minecraft:bone', 'minecraft:bone'])

  // 8x Bone Fragments to 2x Bone
  event.shapeless(Item.of('minecraft:bone', 2), ['kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment'])

    // Grits in Furnace - BlastFurnace - Crossroads
  event.smelting(Item.of('thermal:lead_nugget', 7), 'kubejs:raw_lead_grit').xp(0.7)
  event.smelting(Item.of('thermal:silver_nugget', 7), 'kubejs:raw_silver_grit').xp(0.7)
  event.smelting(Item.of('thermal:nickel_nugget', 7), 'kubejs:raw_nickel_grit').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:platinum_nugget', 7), 'kubejs:raw_platinum_grit').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:zinc_nugget', 7), 'kubejs:raw_zinc_grit').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:bismuth_nugget', 7), 'kubejs:raw_bismuth_grit').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:aluminum_nugget', 7), 'kubejs:raw_aluminum_grit').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:uranium_nugget', 7), 'kubejs:raw_uranium_grit').xp(0.7)
  event.smelting(Item.of('mekanism:nugget_osmium', 7), 'kubejs:raw_osmium_grit').xp(0.7)
  event.smelting(Item.of('kubejs:netherite_scrap_nugget', 7), 'kubejs:raw_netherite_grit').xp(0.7)
  event.blasting(Item.of('thermal:lead_nugget', 7), 'kubejs:raw_lead_grit').xp(0.7)
  event.blasting(Item.of('thermal:silver_nugget', 7), 'kubejs:raw_silver_grit').xp(0.7)
  event.blasting(Item.of('thermal:nickel_nugget', 7), 'kubejs:raw_nickel_grit').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:platinum_nugget', 7), 'kubejs:raw_platinum_grit').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:zinc_nugget', 7), 'kubejs:raw_zinc_grit').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:bismuth_nugget', 7), 'kubejs:raw_bismuth_grit').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:aluminum_nugget', 7), 'kubejs:raw_aluminum_grit').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:uranium_nugget', 7), 'kubejs:raw_uranium_grit').xp(0.7)
  event.blasting(Item.of('mekanism:nugget_osmium', 7), 'kubejs:raw_osmium_grit').xp(0.7)
  event.blasting(Item.of('kubejs:netherite_scrap_nugget', 7), 'kubejs:raw_netherite_grit').xp(0.7)



  // Clumps in Furnace - BlastFurnace - Crossroads
  event.smelting(Item.of('thermal:lead_nugget', 7), 'kubejs:lead_clump').xp(0.7)
  event.smelting(Item.of('thermal:silver_nugget', 7), 'kubejs:silver_clump').xp(0.7)
  event.smelting(Item.of('thermal:nickel_nugget', 7), 'kubejs:nickel_clump').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:platinum_nugget', 7), 'kubejs:platinum_clump').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:zinc_nugget', 7), 'kubejs:zinc_clump').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:bismuth_nugget', 7), 'kubejs:bismuth_clump').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:aluminum_nugget', 7), 'kubejs:aluminum_clump').xp(0.7)
  event.smelting(Item.of('silents_mechanisms:uranium_nugget', 7), 'kubejs:uranium_clump').xp(0.7)
  event.smelting(Item.of('mekanism:nugget_osmium', 7), 'kubejs:osmium_clump').xp(0.7)
  event.smelting(Item.of('kubejs:netherite_scrap_nugget', 7), 'kubejs:netherite_clump').xp(0.7)
  event.blasting(Item.of('thermal:lead_nugget', 7), 'kubejs:lead_clump').xp(0.7)
  event.blasting(Item.of('thermal:silver_nugget', 7), 'kubejs:silver_clump').xp(0.7)
  event.blasting(Item.of('thermal:nickel_nugget', 7), 'kubejs:nickel_clump').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:platinum_nugget', 7), 'kubejs:platinum_clump').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:zinc_nugget', 7), 'kubejs:zinc_clump').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:bismuth_nugget', 7), 'kubejs:bismuth_clump').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:aluminum_nugget', 7), 'kubejs:aluminum_clump').xp(0.7)
  event.blasting(Item.of('silents_mechanisms:uranium_nugget', 7), 'kubejs:uranium_clump').xp(0.7)
  event.blasting(Item.of('mekanism:nugget_osmium', 7), 'kubejs:osmium_clump').xp(0.7)
  event.blasting(Item.of('kubejs:netherite_scrap_nugget', 7), 'kubejs:netherite_clump').xp(0.7)

  // Netherite Scrap Nuggets to Netherite Scrap
  event.shaped(Item.of('minecraft:netherite_scrap'), [
    'NNN',
    'NNN',
    'NNN'
  ], {
    N: 'kubejs:netherite_scrap_nugget',
  })

  // Netherite Scrap back to 9x Netherite Scrap Nuggets
  event.shapeless(Item.of('kubejs:netherite_scrap_nugget', 9), ['minecraft:netherite_scrap'])

  // Connecting Glass
  event.remove({id: 'connectedglass:borderless_glass1'})
  event.shaped(Item.of('connectedglass:borderless_glass', 9), [
    'GGG',
    'GGG',
    'GGG'
  ], {
    G: 'minecraft:glass',
  })


  // Glass Wall
  event.shaped(Item.of('variant16x:glass_wall', 6), [
    ' C ',
    'GGG',
    'GGG'
  ], {
    G: '#forge:glass/colorless',
    C: 'minecraft:cobblestone_wall'
  });


  // Forbidden - Darkstone
  event.shaped(Item.of('forbidden_arcanus:darkstone', 8), [
    'SSS',
    'SRS',
    'SSS'
  ], {
    S: '#forge:stone',
    R: 'forbidden_arcanus:dark_rune'
  })



  // Quark Marble to Chisel Marble
  event.shapeless(Item.of('chisel:marble/raw'), ['quark:marble'])

  // Quark Limestone to Chisel Limestone
  event.shapeless(Item.of('chisel:limestone/raw'), ['quark:limestone'])

  // Minecraft Basalt to Chisel Basalt
  event.shapeless(Item.of('chisel:basalt/raw'), ['minecraft:basalt'])



  // Chisel Marble to Quark Marble
  event.shapeless(Item.of('quark:marble'), ['#chisel:marble'])

  // Chisel Limestone to Quark Limestone
  event.shapeless(Item.of('quark:limestone'), ['#chisel:limestone'])

  // Chisel Basalt to Minecraft Basalt
  event.shapeless(Item.of('minecraft:basalt'), ['#chisel:basalt'])


  // Chisel Raw Charcoal Block
  event.remove({id: 'chisel:charcoal/raw'})
  event.shapeless(Item.of('chisel:charcoal/raw'), ['minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal', 'minecraft:charcoal'])

  event.shapeless(Item.of('minecraft:charcoal', 8), ['#chisel:charcoal'])



  // Iron Chisel
  event.remove({output: 'chisel:iron_chisel'})
  event.shaped(Item.of('chisel:iron_chisel'), [
    ' I ',
    'S  ',
    '   '
  ], {
    S: '#forge:rods/wooden',
    I: 'kubejs:iron_chisel_head'
  })

  // Diamond Chisel
  event.remove({output: 'chisel:diamond_chisel'})
  event.shaped(Item.of('chisel:diamond_chisel'), [
    ' D ',
    'S  ',
    '   '
  ], {
    S: '#forge:rods/wooden',
    D: 'kubejs:diamond_chisel_head'
  })

  // Iron Chisel Head
  event.shaped(Item.of('kubejs:iron_chisel_head'), [
    ' I ',
    ' I ',
    ' N '
  ], {
    I: 'minecraft:iron_ingot',
    N: 'minecraft:iron_nugget',
  })

  // Diamond Chisel Head
  event.shaped(Item.of('kubejs:diamond_chisel_head'), [
    ' D ',
    ' D ',
    ' S '
  ], {
    D: 'minecraft:diamond',
    S: 'silentgear:diamond_shard',
  })

  // Cave Root to Cooked Cave Root
  event.smelting(Item.of('kubejs:cooked_cave_root', 1), 'quark:root_item').xp(0.25)
  event.smoking(Item.of('kubejs:cooked_cave_root', 1), 'quark:root_item').xp(0.25)
  event.recipes.minecraft.campfire_cooking('kubejs:cooked_cave_root', 'quark:root_item')

  // Cave Root to Cooked Cave Root
  event.shapeless(Item.of('tconstruct:crafting_station'), ['#forge:workbench'])


  // Tomato Input
  event.replaceInput(
    {},
    "farmersdelight:tomato",
    "pamhc2crops:tomatoitem"
    )

  // Tomato Output
  event.replaceOutput(
    {},
    "farmersdelight:tomato",
    "pamhc2crops:tomatoitem"
    )


  // Cabbage Input
  event.replaceInput(
    {},
    "farmersdelight:cabbage",
    "pamhc2crops:cabbageitem"
    )

  // Cabbage Output
  event.replaceOutput(
    {},
    "farmersdelight:cabbage",
    "pamhc2crops:cabbageitem"
    )


  // Onion Input
  event.replaceInput(
    {},
    "farmersdelight:onion",
    "pamhc2crops:onionitem"
    )

  // Onion Output
  event.replaceOutput(
    {},
    "farmersdelight:onion",
    "pamhc2crops:onionitem"
    )


  // Rice Input
  event.replaceInput(
    {},
    "farmersdelight:rice",
    "pamhc2crops:riceitem"
    )

  // Rice Output
  event.replaceOutput(
    {},
    "farmersdelight:rice",
    "pamhc2crops:riceitem"
    )

  // Block of Rye
  event.shaped(Item.of('kubejs:block_of_rye'), [
    'RRR',
    'RRR',
    'RRR'
  ], {
    R: 'pamhc2crops:ryeitem',
  })

  // Block of Rye back to 9x Rye
  event.shapeless(Item.of('pamhc2crops:ryeitem', 9), ['kubejs:block_of_rye'])


  // Block of Rice
  event.shaped(Item.of('kubejs:block_of_rice'), [
    'RRR',
    'RRR',
    'RRR'
  ], {
    R: 'pamhc2crops:riceitem',
  })

  // Block of Rye back to 9x Rice
  event.shapeless(Item.of('pamhc2crops:riceitem', 9), ['kubejs:block_of_rice'])


  // Block of Oat
  event.shaped(Item.of('kubejs:block_of_oats'), [
    'OOO',
    'OOO',
    'OOO'
  ], {
    O: 'pamhc2crops:oatsitem',
  })

  // Block of Oat back to 9x Oats
  event.shapeless(Item.of('pamhc2crops:oatsitem', 9), ['kubejs:block_of_oats'])


  // Block of Barley
  event.shaped(Item.of('kubejs:block_of_barley'), [
    'BBB',
    'BBB',
    'BBB'
  ], {
    B: 'pamhc2crops:barleyitem',
  })

  // Block of Barley back to 9x Barley
  event.shapeless(Item.of('pamhc2crops:barleyitem', 9), ['kubejs:block_of_barley'])

  // Mind-Shielding Plate
  event.shaped(Item.of('eidolon:mind_shielding_plate'), [
    'III',
    'III',
    'LSL'
  ], {
    I: '#forge:ingots/lead',
    L: 'minecraft:leather',
    S: 'eidolon:soul_shard',
  })

  // Fiery Torch Fix
  event.replaceInput(
    { id: "druidcraft:fiery_torch" },
    "minecraft:stick",
    "#forge:rods/wooden"
    )

  // Fiery Torch Alternate Recipe
  event.shaped(Item.of('druidcraft:fiery_torch', 64), [
    'F  ',
    'S  ',
    '   '
  ], {
    F: 'twilightforest:fiery_ingot',
    S: '#forge:rods/wooden'
  })

  // Glass Facade - Crossroads
  event.remove({output: 'crossroads:gear_facade_glass'})
  event.shaped(Item.of('crossroads:gear_facade_glass', 8), [
    ' I ',
    'GGG',
    '   '
  ], {
    G: '#forge:glass/colorless',
    I: 'minecraft:iron_ingot'
  })

  // Rope - Druidcraft
  event.remove({id: 'druidcraft:rope'})
  event.shaped(Item.of('druidcraft:rope'), [
    '   ',
    'FFF',
    'FFF'
  ], {
    F: 'immersiveengineering:hemp_fiber',
  })

  // Rusty Iron Ingot
  event.remove({id: 'dustrial_decor:rusty_iron_ingot'})
  event.shaped(Item.of('dustrial_decor:rusty_iron_ingot', 4), [
    ' I ',
    'IWI',
    ' I '
  ], {
    I: 'minecraft:iron_ingot',
    W: 'minecraft:water_bucket'
  })

  // AE2 -  Infinity Booster Card
  event.remove({output: 'ae2wtlib:infinity_booster_card'})
  event.shaped(Item.of('ae2wtlib:infinity_booster_card'), [
    'SWS',
    'FNF',
    'SWS'
  ], {
    W: 'appliedenergistics2:wireless_receiver',
    F: 'appliedenergistics2:fluix_pearl',
    N: 'minecraft:nether_star',
    S: '#forge:ingots/steel'
  });

  // Yellorite Ore - Blasting
  event.blasting(Item.of('biggerreactors:yellorium_ingot', 1), 'biggerreactors:yellorite_ore').xp(1.0)

  // Yellorite Dust - Blasting
  event.blasting(Item.of('biggerreactors:yellorium_ingot', 1), 'biggerreactors:yellorium_dust').xp(1.0)

  // RFTools - Dimension Builder
  event.remove({id: 'rftoolsdim:dimension_builder'})
  event.shaped(Item.of('rftoolsdim:dimension_builder'), [
    'EUE',
    'IMI',
    'AAA'
  ], {
    U: 'mekanism:ultimate_control_circuit',
    E: 'solarflux:emerald_glass',
    M: 'rftoolsbase:machine_frame',
    I: 'rftoolsbase:infused_diamond',
    A: 'betterendforge:aeternium_ingot'
  });

  // RFTools - Machine Frame
  event.remove({id: 'rftoolsbase:machine_frame'})
  event.shaped(Item.of('rftoolsbase:machine_frame'), [
    'IBI',
    'GCG',
    'IBI'
  ], {
    I: '#forge:ingots/iron',
    B: '#forge:dyes/blue',
    G: '#forge:nuggets/gold',
    C: 'silents_mechanisms:circuit_board'
  });

});